Index: pjproject/trunk/pjsip/src/pjsua-lib/getopt.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/getopt.c	(revision 238)
+++ pjproject/trunk/pjsip/src/pjsua-lib/getopt.c	(revision 300)
@@ -19,5 +19,5 @@
 
 /* 
- * getopt entry points
+ * pj_getopt entry points
  *
  * modified by Mike Borella <mike_borella@mw.3com.com>
@@ -33,8 +33,8 @@
 int _getopt_internal (int argc, char *const *argv,
 		      const char *shortopts,
-		      const struct option *longopts, int *longind,
+		      const struct pj_getopt_option *longopts, int *longind,
 		      int long_only);
 
-/* getopt_long and getopt_long_only entry points for GNU getopt.
+/* pj_getopt_long and pj_getopt_long_only entry points for GNU pj_getopt.
    Copyright (C) 1987,88,89,90,91,92,93,94,96,97 Free Software Foundation, Inc.
    This file is part of the GNU C Library.
@@ -68,11 +68,11 @@
 
 int
-getopt_long (int argc, char *const *argv, const char *options, 
-	     const struct option *long_options, int *opt_index)
+pj_getopt_long (int argc, char *const *argv, const char *options, 
+	     const struct pj_getopt_option *long_options, int *opt_index)
 {
   return _getopt_internal (argc, argv, options, long_options, opt_index, 0);
 }
 
-/* Like getopt_long, but '-' as well as '--' can indicate a long option.
+/* Like pj_getopt_long, but '-' as well as '--' can indicate a long option.
    If an option that starts with '-' (not '--') doesn't match a long option,
    but does match a short option, it is parsed as a short option
@@ -80,8 +80,8 @@
  
 int
-getopt (int argc, char * const * argv, const char * optstring)
+pj_getopt (int argc, char * const * argv, const char * optstring)
 {
   return _getopt_internal (argc, argv, optstring,
-			   (const struct option *) 0,
+			   (const struct pj_getopt_option *) 0,
 			   (int *) 0,
 			   0);
@@ -91,9 +91,9 @@
 #define _(msgid)	(msgid)
 
-/* This version of `getopt' appears to the caller like standard Unix `getopt'
+/* This version of `pj_getopt' appears to the caller like standard Unix `pj_getopt'
    but it behaves differently for the user, since it allows the user
    to intersperse the options with the other arguments.
 
-   As `getopt' works, it permutes the elements of ARGV so that,
+   As `pj_getopt' works, it permutes the elements of ARGV so that,
    when it is done, all the options precede everything else.  Thus
    all application programs are extended to handle flexible argument order.
@@ -105,29 +105,29 @@
    they can distinguish the relative order of options and other arguments.  */
 
-/* For communication from `getopt' to the caller.
-   When `getopt' finds an option that takes an argument,
+/* For communication from `pj_getopt' to the caller.
+   When `pj_getopt' finds an option that takes an argument,
    the argument value is returned here.
    Also, when `ordering' is RETURN_IN_ORDER,
    each non-option ARGV-element is returned here.  */
 
-char *optarg = NULL;
+char *pj_optarg = NULL;
 
 /* Index in ARGV of the next element to be scanned.
    This is used for communication to and from the caller
-   and for communication between successive calls to `getopt'.
-
-   On entry to `getopt', zero means this is the first call; initialize.
-
-   When `getopt' returns -1, this is the index of the first of the
+   and for communication between successive calls to `pj_getopt'.
+
+   On entry to `pj_getopt', zero means this is the first call; initialize.
+
+   When `pj_getopt' returns -1, this is the index of the first of the
    non-option elements that the caller should itself scan.
 
-   Otherwise, `optind' communicates from one call to the next
+   Otherwise, `pj_optind' communicates from one call to the next
    how much of ARGV has been scanned so far.  */
 
 /* 1003.2 says this must be 1 before any call.  */
-int optind = 1;
-
-/* Formerly, initialization of getopt depended on optind==0, which
-   causes problems with re-calling getopt as programs generally don't
+int pj_optind = 1;
+
+/* Formerly, initialization of pj_getopt depended on pj_optind==0, which
+   causes problems with re-calling pj_getopt as programs generally don't
    know that. */
 
@@ -145,7 +145,7 @@
 /* Set to an option character which was unrecognized.
    This must be initialized on some systems to avoid linking in the
-   system's own getopt implementation.  */
-
-int optopt = '?';
+   system's own pj_getopt implementation.  */
+
+int pj_optopt = '?';
 
 /* Describe how to deal with options that follow non-option ARGV-elements.
@@ -176,5 +176,5 @@
    The special argument `--' forces an end of option-scanning regardless
    of the value of `ordering'.  In the case of RETURN_IN_ORDER, only
-   `--' can cause `getopt' to return -1 with `optind' != ARGC.  */
+   `--' can cause `pj_getopt' to return -1 with `pj_optind' != ARGC.  */
 
 static enum
@@ -213,5 +213,5 @@
    One subsequence is elements [first_nonopt,last_nonopt)
    which contains all the non-options that have been skipped so far.
-   The other is elements [last_nonopt,optind), which contains all
+   The other is elements [last_nonopt,pj_optind), which contains all
    the options processed since those non-options were skipped.
 
@@ -224,5 +224,5 @@
   int bottom = first_nonopt;
   int middle = last_nonopt;
-  int top = optind;
+  int top = pj_optind;
   char *tem;
 
@@ -272,6 +272,6 @@
   /* Update records for the slots the non-options now occupy.  */
 
-  first_nonopt += (optind - last_nonopt);
-  last_nonopt = optind;
+  first_nonopt += (pj_optind - last_nonopt);
+  last_nonopt = pj_optind;
 }
 
@@ -288,5 +288,5 @@
      non-option ARGV-elements is empty.  */
 
-  first_nonopt = last_nonopt = optind;
+  first_nonopt = last_nonopt = pj_optind;
 
   nextchar = NULL;
@@ -320,14 +320,14 @@
    If an element of ARGV starts with '-', and is not exactly "-" or "--",
    then it is an option element.  The characters of this element
-   (aside from the initial '-') are option characters.  If `getopt'
+   (aside from the initial '-') are option characters.  If `pj_getopt'
    is called repeatedly, it returns successively each of the option characters
    from each of the option elements.
 
-   If `getopt' finds another option character, it returns that character,
-   updating `optind' and `nextchar' so that the next call to `getopt' can
+   If `pj_getopt' finds another option character, it returns that character,
+   updating `pj_optind' and `nextchar' so that the next call to `pj_getopt' can
    resume the scan with the following option character or ARGV-element.
 
-   If there are no more option characters, `getopt' returns -1.
-   Then `optind' is the index in ARGV of the first ARGV-element
+   If there are no more option characters, `pj_getopt' returns -1.
+   Then `pj_optind' is the index in ARGV of the first ARGV-element
    that is not an option.  (The ARGV-elements have been permuted
    so that those that are not options now come last.)
@@ -335,12 +335,12 @@
    OPTSTRING is a string containing the legitimate option characters.
    If an option character is seen that is not listed in OPTSTRING,
-   return '?' after printing an error message.  If you set `opterr' to
+   return '?' after printing an error message.  If you set `pj_opterr' to
    zero, the error message is suppressed but we still return '?'.
 
    If a char in OPTSTRING is followed by a colon, that means it wants an arg,
    so the following text in the same ARGV-element, or the text of the following
-   ARGV-element, is returned in `optarg'.  Two colons mean an option that
+   ARGV-element, is returned in `pj_optarg'.  Two colons mean an option that
    wants an optional arg; if there is text in the current ARGV-element,
-   it is returned in `optarg', otherwise `optarg' is set to zero.
+   it is returned in `pj_optarg', otherwise `pj_optarg' is set to zero.
 
    If OPTSTRING starts with `-' or `+', it requests different methods of
@@ -353,5 +353,5 @@
    argument, it follows the option name in the same ARGV-element, separated
    from the option name by a `=', or else the in next ARGV-element.
-   When `getopt' finds a long-named option, it returns 0 if that option's
+   When `pj_getopt' finds a long-named option, it returns 0 if that option's
    `flag' field is nonzero, the value of the option's `val' field
    if the `flag' field is zero.
@@ -361,5 +361,5 @@
    with other systems.
 
-   LONGOPTS is a vector of `struct option' terminated by an
+   LONGOPTS is a vector of `struct pj_getopt_option' terminated by an
    element containing a name which is zero.
 
@@ -373,22 +373,22 @@
 static int
 _getopt_internal (int argc, char *const *argv, const char *optstring, 
-		  const struct option *longopts, int *longind, 
+		  const struct pj_getopt_option *longopts, int *longind, 
 		  int long_only)
 {
-  optarg = NULL;
-
-  if (optind == 0 || !__getopt_initialized)
+  pj_optarg = NULL;
+
+  if (pj_optind == 0 || !__getopt_initialized)
     {
-      if (optind == 0)
-	optind = 1;	/* Don't scan ARGV[0], the program name.  */
+      if (pj_optind == 0)
+	pj_optind = 1;	/* Don't scan ARGV[0], the program name.  */
       optstring = _getopt_initialize (argc, argv, optstring);
       __getopt_initialized = 1;
     }
 
-  /* Test whether ARGV[optind] points to a non-option argument.
+  /* Test whether ARGV[pj_optind] points to a non-option argument.
      Either it does not have option syntax, or there is an environment flag
      from the shell indicating it is not an option.  The later information
      is only used when the used in the GNU libc.  */
-#define NONOPTION_P (argv[optind][0] != '-' || argv[optind][1] == '\0')
+#define NONOPTION_P (argv[pj_optind][0] != '-' || argv[pj_optind][1] == '\0')
 
   if (nextchar == NULL || *nextchar == '\0')
@@ -398,8 +398,8 @@
       /* Give FIRST_NONOPT & LAST_NONOPT rational values if OPTIND has been
 	 moved back by the user (who may also have changed the arguments).  */
-      if (last_nonopt > optind)
-	last_nonopt = optind;
-      if (first_nonopt > optind)
-	first_nonopt = optind;
+      if (last_nonopt > pj_optind)
+	last_nonopt = pj_optind;
+      if (first_nonopt > pj_optind)
+	first_nonopt = pj_optind;
 
       if (ordering == PERMUTE)
@@ -408,15 +408,15 @@
 	     exchange them so that the options come first.  */
 
-	  if (first_nonopt != last_nonopt && last_nonopt != optind)
+	  if (first_nonopt != last_nonopt && last_nonopt != pj_optind)
 	    exchange ((char **) argv);
-	  else if (last_nonopt != optind)
-	    first_nonopt = optind;
+	  else if (last_nonopt != pj_optind)
+	    first_nonopt = pj_optind;
 
 	  /* Skip any additional non-options
 	     and extend the range of non-options previously skipped.  */
 
-	  while (optind < argc && NONOPTION_P)
-	    optind++;
-	  last_nonopt = optind;
+	  while (pj_optind < argc && NONOPTION_P)
+	    pj_optind++;
+	  last_nonopt = pj_optind;
 	}
 
@@ -426,15 +426,15 @@
 	 then skip everything else like a non-option.  */
 
-      if (optind != argc && !pj_ansi_strcmp(argv[optind], "--"))
-	{
-	  optind++;
-
-	  if (first_nonopt != last_nonopt && last_nonopt != optind)
+      if (pj_optind != argc && !pj_ansi_strcmp(argv[pj_optind], "--"))
+	{
+	  pj_optind++;
+
+	  if (first_nonopt != last_nonopt && last_nonopt != pj_optind)
 	    exchange ((char **) argv);
 	  else if (first_nonopt == last_nonopt)
-	    first_nonopt = optind;
+	    first_nonopt = pj_optind;
 	  last_nonopt = argc;
 
-	  optind = argc;
+	  pj_optind = argc;
 	}
 
@@ -442,10 +442,10 @@
 	 and back over any non-options that we skipped and permuted.  */
 
-      if (optind == argc)
+      if (pj_optind == argc)
 	{
 	  /* Set the next-arg-index to point at the non-options
 	     that we previously skipped, so the caller will digest them.  */
 	  if (first_nonopt != last_nonopt)
-	    optind = first_nonopt;
+	    pj_optind = first_nonopt;
 	  return -1;
 	}
@@ -458,5 +458,5 @@
 	  if (ordering == REQUIRE_ORDER)
 	    return -1;
-	  optarg = argv[optind++];
+	  pj_optarg = argv[pj_optind++];
 	  return 1;
 	}
@@ -465,6 +465,6 @@
 	 Skip the initial punctuation.  */
 
-      nextchar = (argv[optind] + 1
-		  + (longopts != NULL && argv[optind][1] == '-'));
+      nextchar = (argv[pj_optind] + 1
+		  + (longopts != NULL && argv[pj_optind][1] == '-'));
     }
 
@@ -485,10 +485,10 @@
 
   if (longopts != NULL
-      && (argv[optind][1] == '-'
-	  || (long_only && (argv[optind][2] || !my_index (optstring, argv[optind][1])))))
+      && (argv[pj_optind][1] == '-'
+	  || (long_only && (argv[pj_optind][2] || !my_index (optstring, argv[pj_optind][1])))))
     {
       char *nameend;
-      const struct option *p;
-      const struct option *pfound = NULL;
+      const struct pj_getopt_option *p;
+      const struct pj_getopt_option *pfound = NULL;
       int exact = 0;
       int ambig = 0;
@@ -527,6 +527,6 @@
 	{
 	  nextchar += strlen (nextchar);
-	  optind++;
-	  optopt = 0;
+	  pj_optind++;
+	  pj_optopt = 0;
 	  return '?';
 	}
@@ -535,5 +535,5 @@
 	{
 	  option_index = indfound;
-	  optind++;
+	  pj_optind++;
 	  if (*nameend)
 	    {
@@ -541,10 +541,10 @@
 		 allow it to be used on enums.  */
 	      if (pfound->has_arg)
-		optarg = nameend + 1;
+		pj_optarg = nameend + 1;
 	      else
 		{
 		  nextchar += strlen (nextchar);
 
-		  optopt = pfound->val;
+		  pj_optopt = pfound->val;
 		  return '?';
 		}
@@ -552,10 +552,10 @@
 	  else if (pfound->has_arg == 1)
 	    {
-	      if (optind < argc)
-		optarg = argv[optind++];
+	      if (pj_optind < argc)
+		pj_optarg = argv[pj_optind++];
 	      else
 		{
 		  nextchar += strlen (nextchar);
-		  optopt = pfound->val;
+		  pj_optopt = pfound->val;
 		  return optstring[0] == ':' ? ':' : '?';
 		}
@@ -572,14 +572,14 @@
 	}
 
-      /* Can't find it as a long option.  If this is not getopt_long_only,
+      /* Can't find it as a long option.  If this is not pj_getopt_long_only,
 	 or the option starts with '--' or is not a valid short
 	 option, then it's an error.
 	 Otherwise interpret it as a short option.  */
-      if (!long_only || argv[optind][1] == '-'
+      if (!long_only || argv[pj_optind][1] == '-'
 	  || my_index (optstring, *nextchar) == NULL)
 	{
 	  nextchar = (char *) "";
-	  optind++;
-	  optopt = 0;
+	  pj_optind++;
+	  pj_optopt = 0;
 	  return '?';
 	}
@@ -592,11 +592,11 @@
     char *temp = my_index (optstring, c);
 
-    /* Increment `optind' when we start to process its last character.  */
+    /* Increment `pj_optind' when we start to process its last character.  */
     if (*nextchar == '\0')
-      ++optind;
+      ++pj_optind;
 
     if (temp == NULL || c == ':')
       {
-	optopt = c;
+	pj_optopt = c;
 	return '?';
       }
@@ -605,6 +605,6 @@
       {
 	char *nameend;
-	const struct option *p;
-	const struct option *pfound = NULL;
+	const struct pj_getopt_option *p;
+	const struct pj_getopt_option *pfound = NULL;
 	int exact = 0;
 	int ambig = 0;
@@ -615,12 +615,12 @@
 	if (*nextchar != '\0')
 	  {
-	    optarg = nextchar;
+	    pj_optarg = nextchar;
 	    /* If we end this ARGV-element by taking the rest as an arg,
 	       we must advance to the next element now.  */
-	    optind++;
+	    pj_optind++;
 	  }
-	else if (optind == argc)
+	else if (pj_optind == argc)
 	  {
-	    optopt = c;
+	    pj_optopt = c;
 	    if (optstring[0] == ':')
 	      c = ':';
@@ -630,12 +630,12 @@
 	  }
 	else
-	  /* We already incremented `optind' once;
+	  /* We already incremented `pj_optind' once;
 	     increment it again when taking next ARGV-elt as argument.  */
-	  optarg = argv[optind++];
-
-	/* optarg is now the argument, see if it's in the
+	  pj_optarg = argv[pj_optind++];
+
+	/* pj_optarg is now the argument, see if it's in the
 	   table of longopts.  */
 
-	for (nextchar = nameend = optarg; *nameend && *nameend != '='; nameend++)
+	for (nextchar = nameend = pj_optarg; *nameend && *nameend != '='; nameend++)
 	  /* Do nothing.  */ ;
 
@@ -666,5 +666,5 @@
 	  {
 	    nextchar += strlen (nextchar);
-	    optind++;
+	    pj_optind++;
 	    return '?';
 	  }
@@ -677,5 +677,5 @@
 		   allow it to be used on enums.  */
 		if (pfound->has_arg)
-		  optarg = nameend + 1;
+		  pj_optarg = nameend + 1;
 		else
 		  {
@@ -686,6 +686,6 @@
 	    else if (pfound->has_arg == 1)
 	      {
-		if (optind < argc)
-		  optarg = argv[optind++];
+		if (pj_optind < argc)
+		  pj_optarg = argv[pj_optind++];
 		else
 		  {
@@ -714,9 +714,9 @@
 	    if (*nextchar != '\0')
 	      {
-		optarg = nextchar;
-		optind++;
+		pj_optarg = nextchar;
+		pj_optind++;
 	      }
 	    else
-	      optarg = NULL;
+	      pj_optarg = NULL;
 	    nextchar = NULL;
 	  }
@@ -726,12 +726,12 @@
 	    if (*nextchar != '\0')
 	      {
-		optarg = nextchar;
+		pj_optarg = nextchar;
 		/* If we end this ARGV-element by taking the rest as an arg,
 		   we must advance to the next element now.  */
-		optind++;
+		pj_optind++;
 	      }
-	    else if (optind == argc)
+	    else if (pj_optind == argc)
 	      {
-		optopt = c;
+		pj_optopt = c;
 		if (optstring[0] == ':')
 		  c = ':';
@@ -740,7 +740,7 @@
 	      }
 	    else
-	      /* We already incremented `optind' once;
+	      /* We already incremented `pj_optind' once;
 		 increment it again when taking next ARGV-elt as argument.  */
-	      optarg = argv[optind++];
+	      pj_optarg = argv[pj_optind++];
 	    nextchar = NULL;
 	  }